﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;

namespace WG_TimeStyleColumn
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("id", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Time", typeof(DateTime));

            for (int i = 0; i < 10; i++)
            {
                dt.Rows.Add(new object[] {null, DateTime.Now.AddHours(i)});
            }

            
            ultraGrid1.DataSource = dt;
          
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Time"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Time;
        }

        private void ultraGrid1_BeforeExitEditMode(object sender, Infragistics.Win.UltraWinGrid.BeforeExitEditModeEventArgs e)
        {
            var cell = ultraGrid1.ActiveCell;
            if (cell.StyleResolved == Infragistics.Win.UltraWinGrid.ColumnStyle.Time &&
                cell.DataChanged)
            {
                var editor = cell.EditorResolved as EditorWithMask;
                if (editor == null)
                    return;
                // This code assumes the default time format used by the grid.
                string replacedString = new string( new char[]{ cell.Column.PromptChar , cell.Column.PromptChar});
                // This checks if an hour is filled. 
                // If you want to substitute with 00, even if the hour is missing, remove it
                if (cell.Text.IndexOf(replacedString) != 0)
                {
                    editor.SetText(cell.Text.Replace(replacedString, "00"));
                }
              
            }
        }

    }
}
